----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 04/07/2016 04:21:05 PM
-- Design Name: 
-- Module Name: VGA - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity VGAkod is
    Port ( clk50 : in STD_LOGIC;
           rgbin : in STD_LOGIC_VECTOR (2 downto 0);           
           hsync : out STD_LOGIC;
           vsync : out STD_LOGIC;
           rgbd : out STD_LOGIC_VECTOR (2 downto 0);
           cx : out unsigned (9 downto 0);
           cy : out unsigned (9 downto 0);
           en : out STD_LOGIC);
end VGAkod;

architecture Behavioral of VGAkod is

signal hst : unsigned(10 downto 0);
signal vst : unsigned(9 downto 0);
signal rgb : unsigned (2 downto 0);
constant H : integer := 1040;
constant V : integer := 666;
constant Hp : integer := 800;
constant Vp : integer := 600;
constant Hs : integer := 120;
constant Vs : integer := 6;
constant Hf : integer := 856;
constant Vf : integer := 637;

begin
    
    cx <= hst(9 downto 0);
    cy <= vst;
    
    p: process(clk50)
    begin
        if rising_edge(clk50) then
            if hst < H-1 then
                hst <= hst+1;
            else 
                hst <= (others=>'0');
                if vst < V-1 then
                    vst <= vst+1;
                else
                    vst <= (others=>'0');
                end if;
            end if;
        
            if hst<=Hp and vst<=Vp then
                en <= '1';
            else
                en <= '0';
            end if;
                       
            if hst=Hf or hst=Hf+Hs then
                rgbd<="011";
            elsif hst=Hf+1 then
                if vst>=Vf and vst<Vf+Vs then
                    rgbd<="111";
                else
                    rgbd<="101";
                end if;
            elsif hst=Hf+Hs+1 then
                if vst>=Vf and vst<Vf+Vs then
                    rgbd<="010";
                else
                    rgbd<="000";
                end if;
            else
				    if rgb/="011" then
						rgbd<=rgbin;
                else
                  rgbd<="010";
					 end if;
            end if;
            
            
        end if;
    end process;
    
    hsync <= '1' when hst>=Hf and hst<Hf+Hs else '0';
    vsync <= '1' when vst>=Vf and vst<Vf+Vs else '0';
    
end Behavioral;
