library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity ext_control is
 Port ( clk : in STD_LOGIC;
		inc : in STD_LOGIC;
		dec : in STD_LOGIC;
        key : in STD_LOGIC_VECTOR (1 downto 0);
		mode: out STD_LOGIC_VECTOR (4 downto 0);
		scale: out unsigned (2 downto 0); -- "000"-"101", 512, 1k, 2k, 4k, 8k, 16k
		vert1, vert2: out unsigned (2 downto 0); -- vertical scale "000"-"101"
		pos1, pos2:  out unsigned (7 downto 0) -- use pos1 & "00"
        );  
end ext_control;

architecture Behavioral of ext_control is
 signal key1, key1z: std_logic;
 signal keymode: STD_LOGIC_VECTOR (4 downto 0) := "00001";
 signal h: unsigned (2 downto 0) :="000";
 signal v1,v2: unsigned (2 downto 0) :="000";
 signal p1: unsigned (5 downto 0) := "100000";
 signal p2: unsigned (5 downto 0) := "000100";
begin

 mode <= keymode;
 scale <= h;
 vert1 <= v1;
 pos1 <= p1 & "00";
 vert2 <= v2;
 pos2 <= p2 & "00";
 
 -- dodaj opis vezja (Vmesnik 4)

end Behavioral;
